
#include "imag0.h"
#include "lista.h"

typedef struct teline{
  int u0, v0, u1, v1;
  char hv;
  char bn;
  int incl;
  } * tline;

// -------------------- --------------------

void leeRaya (tline *line);

void leeRayas (lista *nlineas);

void imprimeRaya (tline line);

void imprimeRayas (lista lineas);

void imprimeRayasCab (lista lineas, char *text);

void tomaLineasLim (lista *nlineasLim, lista blin, int tamv);

// -------------------- --------------------

void sigueyAgrupaRayasHor (lista *nlineasAgr, tvent vent);

void sigueyAgrupaRayasVer (lista *nlineasAgr, tvent vent);

void sigueyAgrupaRayasHorBlan (lista *nlineasAgr, tvent vent, int lmin);

void pintaAlrededorRaya (tline line, tvent vent, int n);

void pintaAlrededorRayas (lista lineas, tvent vent, int n);

void sigueRayas (tvent vent);

void sigueRayasN (tvent vent, int n);

void sigueRayasBlanLar (tvent vent);

// -------------------- --------------------

int sumaAnchoRayasBlanLarIncl (tvent vent, int incl256);

void posicionLineaCabecera (tline *nlinea, tvent vent);

void posicionMargenColumnas (tline *nlinea, tvent vent);

// void posicionMargenesSeccion (tline *nlinea, tvent vent);

void posicionesMargenesSeccion (lista *nlineas, tvent vent);

// void posicionMargenesMinipage (tline *nlinea, tvent vent);

void posicionesMargenesMinipage (lista *nlineas, tvent vent);

// -------------------- --------------------

lista cortesHorizontalesyVerticales (tvent vent);

void pruebaLine ();

Boolean seCortan (tline l1, tline l2);

void agrupaLineasQueSeCortan (lista *ngrupos,
                              lista lineasH, lista lineasV);

lista lineasdeOrientacion (lista l, char c);

void uneLineasProximas (lista lineas, int dist);

void nlineasMasLargas (lista *lineasLargas, lista lineasagr, int nmax);

void ordenaPor_vx (lista *lineasLargasOv, lista lineasLargas);

Boolean seCortan2 (tline l1, tline l2);

void eliminadasLineasCortadas (lista * lineasVsc, lista lineasV, lista lineasH);  // o H/V

void delimitaParalelogrInterior (tvent *ventn, tvent vent,
              tline linN, tline linS, tline linO, tline linE, int del);

void delimitaParalelogrExterior (tvent *ventn, tvent vent,
              tline linN, tline linS, tline linO, tline linE, int del);

