
#include <stdio.h>
#include <stdlib.h>

#include "lista.h"

void imprimeLatexComienzo ()
{
  printf("\\documentclass[12pt]{book}\n");
  printf("\\usepackage[spanish]{babel}\n");
  printf("\\usepackage{isolatin1}\n");
  printf("\n");
  printf("\\begin{document}\n");
  printf("\n");
}

void imprimeLatexFin ()
{
  printf("\n");
  printf("\\end{document}\n");
}

/**********   ______________   **********/

/* supone misma longitud de cada lista/linea horizontal */
/* supone strlen da la longitud impresa para latex (?!) */
void calculaTamcols (lista *nlt, lista l)
{
  lista lt;
  tnodol ndi;
  tnodol ndj, ndl;
  lista l21;
  tnodol nd3;
  int * pin;
  int t;
  /* tamaos de primera linea de celdas */
  lt = listaNueva ();
  l21 = l->primero->siguiente->siguiente->aitem;
  for (ndi=l21->primero; ndi!=0L; ndi=ndi->siguiente) {
    t = strlen ((char *) ndi->aitem);
    pin = (int *) malloc (sizeof (int));
    *pin = t;
    aniadeafinlista (lt, pin);
    }
  /* tamaos con siguientes lineas de celdas */
  nd3 = l->primero->siguiente->siguiente->siguiente;
  for(ndj=nd3; ndj!=0L; ndj=ndj->siguiente){
    for (ndi=((lista)(ndj->aitem))->primero,
         ndl=lt->primero; ndi!=0L;ndi=ndi->siguiente,
	                          ndl=ndl->siguiente){
      t = strlen ((char *) ndi->aitem);
      pin = (int *) ndl->aitem;
      if (t > *pin)
	*pin = t;
      }
    }
  *nlt = lt;
}

int sumaTams (lista lt)
{
  tnodol ndl;
  int st;
  st=0;
  for (ndl=lt->primero; ndl!=0L; ndl=ndl->siguiente){
    st += *((int *)(ndl->aitem));
    }
  return st;
}

/**********   ______________   **********/

void imprimeLatexPosicion (tpgen g)
{
  printf ("%s|", (char *) g);
}

void imprimeLatexPosiciones (lista l1)
{
  printf("    {|");
  recorreListaAplicando (l1, imprimeLatexPosicion);
  printf("}\n");
}

void imprimeLatexMatriz (tnodol nd2, lista lt)
{
  tnodol ndi, ndj;
  tnodol ndl;
  lista li;
  int st;
  st = sumaTams (lt);
  printf("%*s       \\hline\n",st," ");
  /**/
  for (ndi=nd2; ndi != 0L; ndi=ndi->siguiente){
    /* imprimir una linea */
    li = ndi->aitem;
    for (ndj=li->primero,
         ndl=lt->primero; ndj != 0L; ndj=ndj->siguiente,
	                             ndl=ndl->siguiente){
      printf ("%-*s ", *((int *)(ndl->aitem)), (char *)(ndj->aitem));
      if (ndj->siguiente != 0L)
        printf ("& ");
      }
    printf("\\\\ \\hline\n");
    }
}

void imprimeLatexLista (lista l)
{
  lista l0, l1;
  lista lt;
  tnodol nd2;
  char *tipo;
  calculaTamcols (&lt, l);
  printf("\\begin{tabular}\n");
  l0 = l->primero->aitem;
  tipo = l0->primero->aitem;
  printf ("%% %s\n", tipo);
  if (tipo[0] == '1') {
    /*  '1' un convenio: todos los 'palos' de la 'jaula' */
    l1 = l->primero->siguiente->aitem;
    imprimeLatexPosiciones (l1);
    nd2 = l->primero->siguiente->siguiente;
    imprimeLatexMatriz (nd2, lt);
    }
  printf("\\end{tabular}\n");
  printf("\n");
}
