
#include "base.h"
#include "imag.h"

void imagTextMinsH (timagf *nimag, tvent vent, int dx)
{
  char **pix, **pixT;
  int x, y, tx, ty;
  int x0, x1, xx, gmn, gr;
  timagf imagT;
  tx = vent->tx;
  ty = vent->ty;
  pix  = vent->pix;
  creaImagenPlana (&imagT, 0, vent->tx, vent->ty);
  pixT = imagT->ven0->pix;
  for (y=0; y<ty; y++)
  for (x=0; x<tx; x++){
    gmn = 255;
    x0 = max (0, x-dx);
    x1 = min (x+dx, tx-1);
    for (xx=x0; xx < x1; xx++){
      gr = (pix[y][xx] & 0x0FF) ;
      gmn = min(gmn, gr);
      }
    pixT[y][x] = gmn;
    }
  *nimag = imagT;
}

void imagTextMinsV (timagf *nimag, tvent vent, int dy)
{
  char **pix, **pixT;
  int x, y, tx, ty;
  int y0, y1, yy, gmn, gr;
  timagf imagT;
  tx = vent->tx;
  ty = vent->ty;
  pix  = vent->pix;
  creaImagenPlana (&imagT, 0, vent->tx, vent->ty);
  pixT = imagT->ven0->pix;
  for (x=0; x<tx; x++)
  for (y=0; y<ty; y++){
    gmn = 255;
    y0 = max (0, y-dy);
    y1 = min (y+dy, ty-1);
    for (yy=y0; yy < y1; yy++){
      gr = (pix[yy][x] & 0x0FF) ;
      gmn = min(gmn, gr);
      }
    pixT[y][x] = gmn;
    }
  *nimag = imagT;
}

void imagTextMaxsV (timagf *nimag, tvent vent, int dy)
{
  char **pix, **pixT;
  int x, y, tx, ty;
  int y0, y1, yy, gmx, gr;
  timagf imagT;
  tx = vent->tx;
  ty = vent->ty;
  pix  = vent->pix;
  creaImagenPlana (&imagT, 0, vent->tx, vent->ty);
  pixT = imagT->ven0->pix;
  for (x=0; x<tx; x++)
  for (y=0; y<ty; y++){
    gmx = 0;
    y0 = max (0, y-dy);
    y1 = min (y+dy, ty-1);
    for (yy=y0; yy < y1; yy++){
      gr = (pix[yy][x] & 0x0FF) ;
      gmx = max(gmx, gr);
      }
    pixT[y][x] = gmx;
    }
  *nimag = imagT;
}

