
#include "base.h"
#include "lista.h"

typedef struct tepalabra{
  char * letras;
  int n;
  } * tpalabra;

// typedef lista lexico;

static lista lexicoNuevo;

tpalabra epalabraNueva (char * palabra)
{
  tpalabra palnueva;
  palnueva = (tpalabra) malloc (sizeof (struct tepalabra));
  palnueva->letras = strdup (palabra);
  palnueva->n = 1;
  return palnueva;
}

void iniciaLexicoNuevo ()
{
  lexicoNuevo = listaNueva ();
}

Boolean mismaPalabraEstChs (tpgen estrPalabra, tpgen charPalabra)
{
  char *   lcharPalabra = (char *)   charPalabra;
  tpalabra lestrPalabra = (tpalabra) estrPalabra;
  return strcmp (lestrPalabra->letras,  lcharPalabra) == 0 ;
}

int enlexicoNuevo (char * palabra)
{
  tnodol nodol;
  nodol = buscaEnListaSiFuncEResul (lexicoNuevo, (tpgen) palabra, mismaPalabraEstChs, TRUE);
  if (nodol != 0L)
    return ((tpalabra) nodol->aitem)->n ;
  else
    return 0;
}

void anyadealexicoNuevo (char * palabra)
{
  tnodol nodol;
  tpalabra palnueva;
  nodol = buscaEnListaSiFuncEResul (lexicoNuevo, (tpgen) palabra, mismaPalabraEstChs, TRUE);
  if (nodol != 0L)
    ((tpalabra) nodol->aitem)->n ++;
  else {
    palnueva = epalabraNueva (palabra) ;
    aniadeafinlista (lexicoNuevo, palnueva);
    }
}

